"""
James Rohlf
Clone of the C++ AMC13Tool
05/26/2012
"""

from flashlib_v20 import *
import os
import sys
import string


fdi={}
for dirname, dirnames, filenames in os.walk('../firmware_amc13'):
    i=0
    for filename in filenames:
        #print os.path.join(dirname,filename)
        fdi[i]=filename
        i +=1
#print "The following firmware files were found in firmware_amc13:"
nf=len(fdi)
#for i in xrange(nf): print i, fdi[i]
#print fdi
#open(s,'r')

n=len(fdi)
type={}
for i in xrange(n):
    type[i]='unknown'
    if 'T1' in fdi[i]:
        #print "found T1", fdi[i]
        type[i]='Virtex'
    if 'T2' in fdi[i] and not 'Header' in fdi[i] and not 'Golden' in fdi[i]:
        #print "found T2", fdi[i]
        type[i]='Spartan'
    if 'Header' in fdi[i]:
        type[i]='Header'
    if 'Golden' in fdi[i]:
        type[i]='Golden'
#print type

lengths={}
pad={}
print "The following firmware files were found in firmware_amc13:"
nf=len(fdi)
for i in xrange(nf):
    lengths[i] = len(fdi[i])
#maxlen = max(lengths)
for i in xrange(nf):
    print i, fdi[i], " "*(20 - lengths[i] + 1), type[i]


amc13.spartan=t2
amc13.virtex=t1
t1, t2 = amc13.connect(sn)
amc13x = t2
iloop=1000
while iloop!=0:
    print "type h for menu"
    option = raw_input(">")
    input=option.split()
    #print input
    if option =="h" or option =="help" or option =="ls":
        print "  (.)q quit"
        print "    fv get firmware version"
        print "     i init (reset spartan and virtex and enable TTC)"
        print "   res reset spartan"
        print "   rev reset virtex"
        print "     v virtex voltages" 
        print "     t virtex die temperature"
        print "__________________________________________________________________" 
        print "   enT enable TTC" 
        print "   erT TTC error counts" 
        print " s(v)T n -> read spartan (virtex) TTC n times" 
        print "__________________________________________________________________" 
        print " rs(v) add n      -> single read spartan (virtex) n words from add" 
        print " ws(v) add n      -> single write spartan (virtex) n words from add" 
        print "brs(v) add n      -> block read spartan (virtex) n words from add" 
        print "__________________________________________________________________" 
        print "   vfh verify flash header" 
        print " vs(v) verify spartan (virtex) flash" 
        print "   vbs verify spartan backup flash" 
        print "   PFH program flash header" 
        print " PS(V) program spartan (virtex) flash" 
        print "   PBS program spartan backup flash" 

    if option =="fv":
        z=t2.read("ID",0x0)
        sn=(z & 0xff)
        print "spartan firmware version = ", sn
        z=t1.read("ID",0x0)
        sn=(z & 0xff)
        print " virtex firmware version = ", sn
    if option =="q":
        iloop=0
    if option =="i":
        t1.write("CONTROL0", 0x1);
        t2.write("CONTROL0", 0x1);
        t2.write("TTC_ENABLE", 0xfff);
        print "*** amc13 has been initialized ***"
    if option =="res":
        t2.write("CONTROL0", 0x1);
        print "*** spartan has been issued a reset ***"
    if option =="rev":
        t1.write("CONTROL0", 0x1);
        print "*** spartan has been issued a reset ***"

    if option =="v":
        print "reading virtex voltages:"
        volt=float(t1.read("1.0V_PWR"))/1000.
        print "1.0V_PWR   ", volt, " V"
        volt=float(t1.read("2.5V_PWR"))/1000.
        print "2.5V_PWR   ", volt, " V"
    if option =="t":
        print "reading virtex die temp:"
        temp=float(t1.read("V6_DIE_TEMP"))/1000.
        print "V6 DIE TEMP   ", temp, " C"
    if option =="enT":
        t2.write("TTC_ENABLE", 0xfff);
        print "*** TTC has been enabled ***"
    if option =="erT":
        print "\nTTC error counts:\n"
        print "          single    multi    bunch"
        s = t2.read("TTC_SBERROR");
        m = t2.read("TTC_MBERROR");
        b = t2.read("TTC_BCERROR");
        print "spartan %08x" % s,"%08x" % m,"%08x" % b
        s = t1.read("TTC_SBERROR");
        m = t1.read("TTC_MBERROR");
        b = t1.read("TTC_BCERROR");
        print " virtex %08x" % s,"%08x" % m,"%08x" % b
    if input[0] =="sT":
        n=1
        if (len(input) > 1): n=int(input[1])
        print "\nTTC data from Spartan:\n"
        print "           bunch    event    orbit"
        for i in xrange(n):     
             b = t2.read("TTC_BCN");
             e = t2.read("TTC_EVN");
             o = t2.read("TTC_ORN");
             print "        %08x" % b,"%08x" % e,"%08x" % o
    if input[0] =="vT":
        n=1
        if (len(input) > 1): n=int(input[1])
        print "\nTTC data from Virtex:\n"
        print "           bunch    event    orbit"
        for i in xrange(n):     
             b = t1.read("TTC_BCN");
             e = t1.read("TTC_EVN");
             o = t1.read("TTC_ORN");
             print "        %08x" % b,"%08x" % e,"%08x" % o
#read/write section 
    if input[0] =="rs":
        add=0
        if( len(input) > 1): add=int(input[1],16)
        n=1
        if (len(input) > 2): n=int(input[2],16)
        print "reading from spartan:"
        for iii in xrange(n):
            data=t2.read("ID",add)
            print "        %08x" % add,"%08x" % data
            add +=1
    if input[0] =="rv":
        add=0
        if( len(input) > 1): add=int(input[1],16)
        n=1
        if (len(input) > 2): n=int(input[2],16)
        print "reading from virtex:"
        for iii in xrange(n):
            data=t1.read("ID",add)
            print "        %08x" % add,"%08x" % data
            add +=1
    if input[0] =="ws":
        add=0
        if( len(input) > 1): add=int(input[1],16)
        data=0
        print data
        if( len(input) > 2): data=int(input[2],16)
        n=1
        if (len(input) > 3): n=int(input[3],16)
        print "writing to spartan:"
        for iii in xrange(n):
            t2.write("ID",data,add)
            print "        %08x" % add,"%08x" % data
            add +=1
            data +=1
    if input[0] =="wv":
        add=0
        if( len(input) > 1): add=int(input[1],16)
        data=0
        print data
        if( len(input) > 2): data=int(input[2],16)
        n=1
        if (len(input) > 3): n=int(input[3],16)
        print "writing to virtex:"
        for iii in xrange(n):
            t1.write("ID",data,add)
            print "        %08x" % add,"%08x" % data
            add +=1
            data +=1
#program/verify flash section 
    enter=0
    if (input[0] =="vfh" or input[0] =="vbs" or input[0] =="vs" or input[0] =="vv"): enter =1
    if (input[0] =="PFH" or input[0] =="PBS" or input[0] =="PS" or input[0] =="PV"): enter =1
    if enter==1:
        if input[0] =="vfh" or input[0] =="PFH": 
            s='../firmware_amc13/AMC13T2Header.mcs'
            offset=0x0
        if input[0] =="vbs"or input[0] =="PBS": 
            s='../firmware_amc13/AMC13T2Golden.mcs'
            offset=0x100000
        if input[0] =="vs" or input[0] =="PS": 
            s='../firmware_amc13/AMC13T2v6.mcs'
            offset=0x200000
        if input[0] =="vv" or input[0] =="PV": 
            s='../firmware_amc13/AMC13T1v3.mcs'
            offset=0x400000
        d={}
        q=fillDataDict(d,s)
        n=len(d)
        npages=n/256
        remainder=n%256
        if remainder !=0: npages +=1
        zerosneeded=256-remainder
        if(zerosneeded != 0):
            for i in xrange(zerosneeded): d[n+i]=0
        print "\nfirmware file", s, "has", hex(n), "data bytes  (",npages," pages)"
        if input[0] =="vfh" or input[0] =="vbs" or input[0] =="vs" or input[0] =="vv": verifyflash(npages,offset,d)
        if input[0] =="PFH" or input[0] =="PBS" or input[0] =="PS" or input[0] =="PV": 
            print "WARNING: you are about to reprogram flash memory. Are you sure? (y)"
            yo=raw_input(">")
            if(yo=="y" or yo=="yes"): programflash(npages,offset,d)








