from flashcommands_v20 import *
def zeroflash(np,offset):
#zero the flash np pages with address offset 
   kpages=np/1024
   koffset=offset/1024/256
   remainder=kpages%1024
   if remainder !=0: kpages +=1
   if(kpages==0): kpages +=1
   for i in xrange(kpages): eraseFlashSector(i+koffset)
   print "\n"

def programflash(np,offset,d):
#program flash np pages with address offset, data in dictionary d 
#write data in 256 word blocks in reverse order
   address=256*(np-1)
#print out message every 300 pages
#page loop

   for i in xrange(np):
      #data loop
      data=[]
      for j in xrange(256):
         data.append(d[address+j])
      #write to flash
      if i==0: print "programming flash at address", hex(address+offset)
      if (i+1)%300 ==0: print "programming flash at address", \
          hex(address+offset), "\t % done =", (i+50)*100/np
      programFlashPage(address+offset, 256, data)
      address -=256
   print "\n"

def verifyflash(np,offset,d):
   #read back data and verify
   ierr=0
   index=0
   add=0
   i=0
   nreads = np
   while i < nreads:
      if i==0: print "reading/checking flash at address ", hex(add+offset)
      if (i+1)%300 ==0: print "reading/checking flash at address ", hex(add+offset),            "\t % done = ", (i+50)*100/np 
      R=readFlashData(add+offset,256)
      j=0
      while j < 256 and index < np*256:
         r=int(R[j])
#         if(i>3128): print hex(d[index]), "  ", hex(r)
         if d[index] !=  r:
            print "flash programming error, read no., byte =", i,j, "wrote", \
                 hex(d[index]), "and read back ", hex(r)
            #print R
            ierr=1
            raw_input('\n')
         j +=1
         index +=1
      add +=256
      i +=1
   if ierr ==0: print "AMC13 flash successfully verified, no. pages =", np  


def fillDataDict(d,s):
#this function reads all the data from file s into dictionary d
#the dictionary key is the address and the value is the byte of data 
# import mmap
 index=0
 iquit=0
 f=open(s, 'r')
# map = mmap.mmap(f.fileno(), 0)
 while iquit==0:
    #read first character which must be a colon
    x = f.read(1)
    if x != ':' :
        print 'Start char error, expected colon at beginning of line'
        print "stopping flash programming"
        raw_input('\n')
    #read next byte which is number of data bytes in the line of code
    b = int(f.read(2),16)
    #read address 2 bytes in two steps to make checksum easy
    a1 = f.read(2)
    a2 = f.read(2)
    #combine bytes to get address (add)
    add = int(a1+a2,16)
    #read record type 00 is data, 01 is end of file
    #other record types for now we do not care about
    rectyp =int(f.read(2),16)
    i = 0
    data_sum=0
    #loop over data
    while i < b :
        data = int(f.read(2),16)
        data_sum +=data
        if rectyp==0:
           d[index] = data
           index +=1
        i +=1
    #read check sum byte
    csum = int(f.read(2),16)
    #checksum
    check = b+ int(a1,16)+int(a2,16) + rectyp +data_sum
    #perform checksum, sum of all bytes inclduding checksum must be zero in the last byte
    check=(check+csum)&0xff
    if check !=0:
       print "check sum error in file", s
       print "stopping flash programming"
       raw_input('\n')
    #read end of line
    burn = f.read(1)
    #check for end of file
    if rectyp == 1: iquit=1
 f.close
 return (0)
