#!/usr/bin/env python
#
# quick pseudo-ping for IPBus clients on private network

from socket import *
import signal
import sys
PORT = 50001
NET = '192.168.1.'
TIMEOUT = 0.1

# normal response from IPbus device
ref = chr(0x10)+chr(0x6e)+chr(0)+chr(0xfc)

# exit on ctrl-c
def sigh(signal, frame):
    print
    print "exiting..."
    sys.exit()

# construct an IPBus header in network byte order
def hdr(id, len, type):
    id_h = id >> 7
    id_l = id & 0x3f
    len_h = len >> 8
    len_l = len & 0xff
    return( chr( 0x10 | id_h) + chr( ((id_l)<<1) | len_h ) + chr(len_l) + chr( type << 3));

print "Scanning IP addresses from 192.168.1.254 downto 192.168.1.1 for IPbus devices"
print "Type ctrl-C any time to exit"

nf = 0
signal.signal(signal.SIGINT, sigh)

for i in xrange(253):
    s = socket( AF_INET, SOCK_DGRAM)
    a = 254-i
    HOST = NET + str(a)
    sys.stdout.write('.')
    sys.stdout.flush()
    s.connect((HOST, PORT))
    s.settimeout(TIMEOUT)
    # send a "byte order" transaction
    msg = hdr( 55, 0, 0x1f)
    try:
        s.sendall( msg)
        data = s.recv(1024)
    except timeout:
        data = ''
    except error:
        print
        print HOST, ': connection error'
    s.close()
    r = ''
    if data != '':
        nf += 1
        print
        if len(data)>3 and data[0:4] == ref:
            r = ' IPBus device'
        else:
            r = ' data'
            for i in xrange( len(data)):
                r += " " + hex(ord(data[i]))
        print HOST, r
print
print nf,"iPbus clients found in range 192.168.254...1"
